' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright
VERSION 5.00
Begin VB.Form ProcessRes 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form2"
   ClientHeight    =   4704
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   6336
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4704
   ScaleWidth      =   6336
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ResultTable 
      Height          =   4692
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   6372
   End
End
Attribute VB_Name = "ProcessRes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public Sub ProcessResults(result As DXResultsOD)
  Dim cnt As Integer
  cnt = 0

  ' First retrieve the documents/folders from the results collection
  Dim ddo As DXDDOOD
  Dim cursor As DXSequentialIteratorOD
  Set cursor = result.createIterator
  Do While cursor.more
    Set ddo = cursor.Next
    'ddo.retrieve
    cnt = cnt + 1
    'Display the data
    If Not (ddo Is Nothing) Then
     DisplayDDO ddo, cnt
    End If
  Loop                             ' end do while cursor.more
End Sub

Public Sub DisplayDDO(ddo As DXDDOOD, cnt As Integer)

  Dim ItemType As Integer, count As Integer, i As Integer
  Dim pid As DXPidOD
  Dim strPidString As String
  Dim dataName As String
  Dim data As Variant
  Dim dataObj As Object
  Dim aVar As Variant
  aVar = ddo.getPropertyByName(DX_OD_PROPERTY_ITEM_TYPE)
  ItemType = aVar
  ResultTable.Text = ResultTable.Text & "=====> Item " & cnt & "<=====" & vbCrLf
  Set pid = ddo.getPidObject
  strPidString = pid.pidString
  ResultTable.Text = ResultTable.Text & "pid " & strPidString & vbCrLf
  ResultTable.Text = ResultTable.Text & "********************" & vbCrLf
  Select Case ItemType
    Case DX_OD_DOCUMENT
      ResultTable.Text = ResultTable.Text & "Item is a document" & vbCrLf
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_OD_DKPARTS Then
         'ResultTable.Text = ResultTable.Text & "**DKParts**" & vbCrLf
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessParts dataObj
         End If
        ElseIf dataName = DX_OD_DKVIEWDATA Then
         'ResultTable.Text = ResultTable.Text & "**Logical Views**" & vbCrLf
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessViews dataObj
         End If
        ElseIf dataName = DX_OD_DKFIXEDVIEWDATA Then
         'ResultTable.Text = ResultTable.Text & "**Fixed View**" & vbCrLf
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessBlobs dataObj
         End If
        ElseIf dataName = DX_OD_DKRESOURCE Then
         'ResultTable.Text = ResultTable.Text & "**Resource**" & vbCrLf
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessBlobs dataObj
         End If
        Else
         data = ddo.GetData(i)
         If VarType(data) = vbString Or VarType(data) = vbInteger Or _
            VarType(data) = vbLong Or VarType(data) = vbShort Then
           ResultTable.Text = ResultTable.Text & "attribute name: " & dataName & vbCrLf
           ResultTable.Text = ResultTable.Text & "value: " & data & vbCrLf
         End If
        End If
      Next                         ' end for i = 1 to count
    Case DX_OD_FOLDER
      ResultTable.Text = ResultTable.Text & "Item is a folder" & vbCrLf
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_OD_DKFOLDER Then
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessFolder dataObj
         End If
        Else
          data = ddo.GetData(i)
          If VarType(data) = vbString Or VarType(data) = vbInteger Or _
             VarType(data) = vbLong Or VarType(data) = vbShort Then
            ResultTable.Text = ResultTable.Text & "attribute name: " & dataName & vbCrLf
            ResultTable.Text = ResultTable.Text & "value: " & data & vbCrLf
          End If
        End If
      Next                         ' end for i = 1 to count
  End Select

End Sub

Public Sub ProcessParts(parts As DXPartsOD)

  ResultTable.Text = ResultTable.Text & "This document has " & parts.cardinality & " parts" & vbCrLf
  Dim dataObjCursor As DXSequentialIteratorOD
  Set dataObjCursor = parts.createIterator
  Dim pidXDO As DXPidXDOOD
  Dim j As Integer
  j = 0
  Dim dkObj As Object
  Dim dkXDO As DXBlobOD
  Dim ItemType As Long
  Dim MimeType As String

  Do While dataObjCursor.more
    j = j + 1
    ResultTable.Text = ResultTable.Text & "--------------------" & vbCrLf
    Set dkObj = dataObjCursor.Next
    If TypeOf dkObj Is DXBlobOD Then
      'Do something with the blob
      Set dkXDO = dkObj
      Set pidXDO = dkObj.getPidObject()
      ItemType = pidXDO.getType()
      MimeType = dkXDO.getMimeType()
      If ItemType = DK_OD_SEGMENT Then
        ResultTable.Text = ResultTable.Text & "OD Data (" & MimeType & ") blob - "
      ElseIf ItemType = DX_OD_ANNOTATION Then
        ResultTable.Text = ResultTable.Text & "OD Note (" & MimeType & ") blob - "
      ElseIf ItemType = DK_OD_RESOURCE Then
        ResultTable.Text = ResultTable.Text & "OD Resource (" & MimeType & ") blob - "
      ElseIf ItemType = DK_OD_VIEW Then
        ResultTable.Text = ResultTable.Text & "OD Logical View (" & MimeType & ") blob - "
      ElseIf ItemType = DK_OD_FIXED_VIEW Then
        ResultTable.Text = ResultTable.Text & "OD Fxied View (" & MimeType & ") blob - "
      End If
      ResultTable.Text = ResultTable.Text & "pid value " & pidXDO.pidString & vbCrLf
    Else
      ResultTable.Text = ResultTable.Text & "Unknown type of object!" & vbCrLf
    End If
  Loop                   ' end do while dataObjCursor.more

End Sub

Public Sub ProcessViews(views As DXViewDataOD)

  Dim pidXDO As DXPidXDOOD
  ResultTable.Text = ResultTable.Text & "This document has " & views.cardinality & " views" & vbCrLf
  Dim dataObjCursor As DXSequentialIteratorOD
  Set dataObjCursor = views.createIterator
  Dim j As Integer
  j = 0
  Dim dkObj As Object
  Dim dkXDO As DXBlobOD
  Dim ItemType As Long
  Dim MimeType As String

  Do While dataObjCursor.more
    j = j + 1
    ResultTable.Text = ResultTable.Text & "--------------------" & vbCrLf
    Set dkObj = dataObjCursor.Next
    If TypeOf dkObj Is DXBlobOD Then
      'Do something with the blob
      Set dkXDO = dkObj
      Set pidXDO = dkObj.getPidObject()
      ItemType = pidXDO.getType()
      MimeType = dkXDO.getMimeType()
      If ItemType = DK_OD_SEGMENT Then
        ResultTable.Text = ResultTable.Text & "OD Data (" & MimeType & ") blob - "
      ElseIf ItemType = DX_OD_ANNOTATION Then
        ResultTable.Text = ResultTable.Text & "OD Note (" & MimeType & ") blob - "
      ElseIf ItemType = DK_OD_RESOURCE Then
        ResultTable.Text = ResultTable.Text & "OD Resource (" & MimeType & ") blob - "
      ElseIf ItemType = DK_OD_VIEW Then
        ResultTable.Text = ResultTable.Text & "OD Logical View (" & MimeType & ") blob - "
      ElseIf ItemType = DK_OD_FIXED_VIEW Then
        ResultTable.Text = ResultTable.Text & "OD Fxied View (" & MimeType & ") blob - "
      End If
      ResultTable.Text = ResultTable.Text & "pid value " & pidXDO.pidString & vbCrLf
    Else
      ResultTable.Text = ResultTable.Text & "Unknown type of object!" & vbCrLf
    End If
  Loop                   ' end do while dataObjCursor.more

End Sub

Public Sub ProcessBlobs(blobs As DXBlobOD)

  Dim pidXDO As DXPidXDOOD
  Dim dkXDO As DXBlobOD
  Dim ItemType As Long
  Dim MimeType As String

  'Do something with the blob
  ResultTable.Text = ResultTable.Text & "--------------------" & vbCrLf
  Set dkXDO = blobs
  Set pidXDO = dkXDO.getPidObject()
  ItemType = pidXDO.getType()
  MimeType = dkXDO.getMimeType()
  If ItemType = DK_OD_SEGMENT Then
    ResultTable.Text = ResultTable.Text & "OD Data (" & MimeType & ") blob - "
  ElseIf ItemType = DX_OD_ANNOTATION Then
    ResultTable.Text = ResultTable.Text & "OD Note (" & MimeType & ") blob - "
  ElseIf ItemType = DK_OD_RESOURCE Then
    ResultTable.Text = ResultTable.Text & "OD Resource (" & MimeType & ") blob - "
  ElseIf ItemType = DK_OD_VIEW Then
    ResultTable.Text = ResultTable.Text & "OD Logical View (" & MimeType & ") blob - "
  ElseIf ItemType = DK_OD_FIXED_VIEW Then
    ResultTable.Text = ResultTable.Text & "OD Fxied View (" & MimeType & ") blob - "
  End If
  ResultTable.Text = ResultTable.Text & "pid value " & pidXDO.pidString & vbCrLf

End Sub

Public Sub ProcessFolder(folder As DXFolderOD)

  Dim cnt As Integer
  cnt = 0

  ' First retrieve the documents/folders from the results collection
  Dim ddo As DXDDOOD
  Dim cursor As DXSequentialIteratorOD
  Set cursor = folder.createIterator

  Do While cursor.more
    Set ddo = cursor.Next
    ddo.retrieve
    cnt = cnt + 1
    DisplayDDO ddo, cnt
  Loop                             ' end do while cursor.more

End Sub


