/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

// sample combined-query optimise: Parametric, Text and Image 
/*
 * Filename       : TCQPQTQIQOPT.cpp
 * Description    : Test Combined Query, Parametric, Text & Image Query,
 *                : no scope
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreDL.hpp>
#include <DKDatastoreTS.hpp>

#include <DKDatastoreQBIC.hpp>

#include <DKException.hpp>
#include <DKString.hpp>
#include <DKDDO.hpp>
#include <DKAny.hpp>
#include <DKPid.hpp>
#include <dkCollection.hpp>
#include <dkXDO.hpp>
#include <DKBlobDL.hpp>
#include <DKParametricQuery.hpp>
#include <DKTextQuery.hpp>

#include <DKImageQuery.hpp>

#include <DKCombinedQueryOptDL.hpp>
#include <DKCombinedQuery.hpp>
#include <DKResults.hpp>

#include <dkResultSetCursor.hpp>
#include <DKEnvironment.hpp>

// DL logon
#define DLSERVER   "libsrvrx"
#define DLUID      "frnadmin"
#define DLPWD      "password"

// TM logon
#define TMSERVICE  "TM"

// QBIC logon
#define QBSERVER   "qbicsrv"
#define QBUID      "frnadmin"
#define QBPWD      "password"
#define QBDB       "QBICDB"
#define QBCAT      "QBICCAT"

// DE logon
#define DE_CONNECT "SQLDSTYPE=DB2;SQLUID=db2inst1;SQLPWD=ibmdb2;SQLLSUID=lsadmin"

void main(int argc, char *argv[])
{
DKDatastoreDL        *dsDL   = NULL;
DKDatastoreTS        *dsTS   = NULL;
DKDatastoreQBIC      *dsQBIC = NULL;
DKParametricQuery    *pq;
DKTextQuery          *tq;
DKImageQuery         *iq;
DKCombinedQueryOptDL *cq;

int  selection;

while(1) {                   // loop forever  
  try {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    cout << " *** Test Combined Query : Parametric, Text & Image Query, no scope " << endl;
 
    selection = 0;
    cout << "Select a number for combined query:" << endl;
   
    if ( !selection ) {
      cout << " 1    Parametric and  Text and Image Query" << endl;
      cout << " 2    Parametric and  Text Query" << endl;
      cout << " 3    Parametric and  Image Query" << endl;
      cout << " 4    Parametric Query only" << endl;
      cout << " 5    Exit" << endl;
      cout << " " << endl;
      cout << " " << endl;

      scanf("%d", &selection);
      cout << " Your selection is " << selection << endl;
      }

    if ( selection == 5 ) {
      cout << " Exiting ..." << endl;
      if (dsDL != NULL) {
        if (dsDL->isConnected()) {
          dsDL->disconnect();
          cout << "datastore DL disconnected" << endl; 
          }
        delete dsDL;
        }
      if (dsTS != NULL) {
        if (dsTS->isConnected()) {
          dsTS->disconnect();
          cout << "datastore TS disconnected" << endl; 
	  }
        delete dsTS;
        }
      if (dsQBIC != NULL) {
        if (dsQBIC->isConnected()) {
          dsQBIC->closeCatalog();
          dsQBIC->disconnect();
          cout << "datastore QBIC disconnected" << endl; 
	  }
        delete dsQBIC;
        }
      cout << " Have a nice day !!! " << endl;
      exit(0);
      }

    if ( selection < 1 || selection > 5 ) {
      cout << " Invalid selection.  exiting ..." << endl;
      continue;
      }

    pq = NULL;
    tq = NULL;
    iq = NULL;
    cq = NULL;

    if ( selection != 5 ) {
      if (dsDL == NULL) dsDL = new DKDatastoreDL;
      cout << "connecting to datastore DL" << endl; 
      if (!(dsDL->isConnected())) 
        dsDL->connect(DLSERVER,DLUID,DLPWD,DE_CONNECT);

      if (dsDL->isConnected()) {
        cout << "datastore DL connected" << endl; 
        }
      else {
        cout << "dsDL isConnected() returns FALSE" << endl;
        exit(1);
        }

      // prepare query string for Parametric Search
      DKString pcmd = "SEARCH=(INDEX_CLASS=DLSAMPLE,COND=(DLSEARCH_Date >= '1994'));";
      pcmd = pcmd + "OPTION=(CONTENT=NO;";
      pcmd = pcmd + "TYPE_FILTER=FOLDERDOC)";
      pq = (DKParametricQuery*) dsDL->createQuery(pcmd,DK_CM_PARAMETRIC_QL_TYPE,NULL);
      cout << " parametric query string " << pcmd << endl;
      }

    if ( selection==1 || selection==2  ) {
      if (dsTS == NULL) dsTS = new DKDatastoreTS;
      cout << "connecting to datastore TS" << endl; 
      if (!(dsTS->isConnected())) 
        dsTS->connect(TMSERVICE,"",' '); 

      if (dsTS->isConnected())  {
        cout << "datastore TS connected" << endl; 
        }
      else  {
        cout << "dsTS isConnected() returns FALSE" << endl;
        exit(2);
        }
      // prepare query string for Text Search
      DKString tcmd = "SEARCH=(COND=('UNIX'));";
      tcmd = tcmd +   "OPTION=(SEARCH_INDEX=TMINDEX;MAX_RESULTS=50)";
      tq = (DKTextQuery*) dsTS->createQuery(tcmd,DK_CM_TEXT_QL_TYPE,NULL);
      cout << " text query string " << tcmd << endl;
      }

    if ( selection==1 || selection==3 ) {
      if (dsQBIC == NULL) dsQBIC = new DKDatastoreQBIC;
      cout << "connecting to datastore QBIC" << endl;

      if (!(dsQBIC->isConnected())) 
        dsQBIC->connect(QBSERVER,QBUID,QBPWD, 
                      "DATABASE = qbicdb; CATALOG = qbiccat; LIBSERVER = JAWULIB");

      if (dsQBIC->isConnected())  {
        cout << "datastore connected" << endl;

        dsQBIC->openCatalog(QBDB, QBCAT);  
        cout << "catalog opened" << endl;
        }
      else {
        cout << "dsQBIC isConnected() returns FALSE" << endl;
        exit(3);
        }

      // prepare query string for Image Search
      DKString icmd = "QbColorFeatureClass color=<63,121,61>"; // R,G,B values
      iq = (DKImageQuery*) dsQBIC->createQuery(icmd,DK_IMAGE_QL_TYPE,NULL);
      cout << " image query string " << icmd << endl;
      }

    {
    DKNVPair par[4];

    switch(selection) {
      case 1:     //do PQ/TQ/IQ combine:
        par[0].set(DK_CM_PARM_QUERY, pq);
        par[1].set(DK_CM_IMAGE_QUERY, iq);
        par[2].set(DK_CM_TEXT_QUERY, tq);
        par[3].setName(DK_CM_PARM_END);
        cout << "executing combined query (pq & tq & iq)" << endl;
        break; 

      case 2:     //do PQ/TQ combine:
        par[0].set(DK_CM_PARM_QUERY, pq);
        par[1].set(DK_CM_TEXT_QUERY, tq);
        par[2].setName(DK_CM_PARM_END);
        cout << "executing combined query (pq & tq)" << endl;
        break;

      case 3:     //do PQ/IQ combine:
        par[0].set(DK_CM_PARM_QUERY, pq);
        par[1].set(DK_CM_IMAGE_QUERY, iq);
        par[2].setName(DK_CM_PARM_END);
        cout << "executing combined query (pq & iq)" << endl;
        break;

      case 4:     //do PQ only:
        par[0].set(DK_CM_PARM_QUERY, pq);
        par[1].setName(DK_CM_PARM_END);
        cout << "executing combined query (pq only)" << endl;
        break;
  
      default:
        break;
      }

    cq = new DKCombinedQueryOptDL;
#ifdef WIN32
#ifdef _DEBUG
    DebugBreak();
#endif
#endif
    cq->execute(par);
    cout << "cq query executed" << endl;

    if (pq != NULL) delete pq;    
    if (tq != NULL) delete tq;    
    if (iq != NULL) delete iq;    
    }

  DKDDO* pDDO = NULL;
  dkXDO* pXDO = NULL;
  DKPidXDO* pidXDO = NULL;
  DKPidXDODL* pidXDODL = NULL;
  DKBlobDL* pDKBlobDL = NULL;

  int i = 0;
  short j = 0;
  int resultCounter = 0;
  int numDataItems = 0;
  short propid = 0;
  dkCollection* pCol = NULL;
  dkResultSetCursor* pCur = 0;

  pCur = cq->resultSetCursor();

  if (pCur == NULL) {
    cout << " CQ resultSetCursor is NULL " << endl;  
    continue;
    }
  else if (pCur->cardinality() == 0) {
    cout << " CQ resultSetCursor is empty " << endl;  
    delete pCur;
    continue;
    }

  cout << " CQ number of results = " << pCur->cardinality() << endl;  
      
  if (cq) delete cq;

  DKDDO *p = 0;
  dkDataObjectBase *pDOBase = 0;
  DKAny a;
  ushort k = 0;
  ushort val = 0;
  ushort cnt = 1;
  DKString strData = "";
  DKString strDataName = "";
  dkCollection* pdCol = 0;
  dkIterator*  pdIter = 0;
  DKPid *pid = 0;
  DKString strPid;
  long pidIdCnt = 0;
  long pidIndex = 0;
  while (pCur->isValid()) {
    p = pCur->fetchNext();
    if (p != 0) {
      cout << "==========> " << "Item " << cnt << " <=========" << endl;
      numDataItems = p->dataCount();
      pid = (DKPid*)p->getPidObject();
      strPid = pid->pidString();
      cout << "pid string " << strPid << endl;
      cout << "pid id string " << pid->getId() << endl;
      strPid = pid->getIdString();
      cout << "pid idString " << strPid << endl;
      pidIdCnt = pid->getIdStringCount();
      cout << "pid idString cnt " << pidIdCnt << endl;
      strPid = pid->getPrimaryId();
      cout << "pid primary id " << strPid << endl;
      pidIndex = 0;
      strPid = pid->getIdString(pidIndex);
      cout << "pid item id " << strPid << endl;
      k = p->propertyId(DK_CM_PROPERTY_ITEM_TYPE);
      if (k > 0) {
        a = p->getProperty(k);
        val = a;
        cout << "******************************" << endl;
        switch (val) {
          case DK_CM_DOCUMENT : 
            cout << "Item is document " << endl;
            break;
          case DK_CM_FOLDER :
            cout << "Item is folder " << endl;
            break;
        }
        cout << "******************************" << endl;
      }
      cout << "Number of Data Items " << numDataItems << endl;
      for (j = 1; j <= numDataItems; j++) {
        a = p->getData(j);
        strDataName = p->getDataName(j);
        switch (a.typeCode()) {
  	      case DKAny::tc_collection : {
            pdCol = a;
            cout << strDataName << " collection name : " << strDataName << endl;
            cout << "--------------------------------------" << endl;
            pdIter = pdCol->createIterator();
            ushort b = 0;
            while (pdIter->more() == TRUE) {
              b++;
              cout << "  -------------------------------------------------" << endl;
	          a = *(pdIter->next());
	          pDOBase = a;
	          if (pDOBase->protocol() == DK_CM_PDDO) {
	             pDDO = (DKDDO*)pDOBase;
	             cout << "  DKDDO object " << b << " in " << strDataName << " collection " << endl;
	             k = pDDO->propertyId(DK_CM_PROPERTY_ITEM_TYPE);
	             if (k > 0) {
	                a = pDDO->getProperty(k);
	                val = a;
	                cout << "  ******************************" << endl;
	                switch (val) {
	                  case DK_CM_DOCUMENT :
                        cout << "  Item is document " << endl;
	                    break;
	                  case DK_CM_FOLDER :
	                    cout << "  Item is folder " << endl;
	                    break;
                    }
	                cout << "  ******************************" << endl;
                 }
              }
	          else if (pDOBase->protocol() == DK_CM_XDO) {
    	        pXDO = (dkXDO*)pDOBase;
	            cout << "  dkXDO object " << b << " in " << strDataName << " collection " << endl;
	            pidXDO = (DKPidXDODL*)pXDO->getPid();
  	            strPid = pidXDO->pidString();
	            cout << "XDO pid string " << strPid << endl;
	            strPid = pidXDO->getId();
	            cout << "XDO pid id string " << strPid << endl;
	            strPid = pidXDO->getIdString();
	            cout << "XDO pid idString " << strPid << endl;
                pidIdCnt = pidXDO->getIdStringCount();
 	            cout << "XDO pid idString cnt " << pidIdCnt << endl;
	            strPid = pidXDO->getPrimaryId();
	            cout << "XDO pid primary id " << strPid << endl;
	            pidIndex = 0;
	            strPid = pidXDO->getIdString(pidIndex);
	            cout << "XDO pid item id " << strPid << endl;
	            pidIndex = 1;
	            strPid = pidXDO->getIdString(pidIndex);
	            cout << "XDO pid part no " << strPid << endl;
	            pidIndex = 2;
	            strPid = pidXDO->getIdString(pidIndex);
	            cout << "XDO pid rep type " << strPid << endl;
              }
            } // while
            if (pdIter != 0)  delete pdIter;
            if (b == 0)
              cout << strDataName << " collection has no elements " << endl;
            cout << "  -------------------------------------------------" << endl;
            }
            break;
  	      case DKAny::tc_null: 
            cout << "attribute ID: " << j << " name : " << strDataName << " value is null " << endl;
            break;
 	      default:
            cout << "attribute ID: " << j << " name : " << strDataName << " value : " << a << endl;
            break;
        }
       }         
      }
      cnt++;
      delete p;
      }
    if (pCur != NULL) delete pCur;

    cout << "query results processed" << endl;
  }  // try
      
  catch (DKException& exc)    {
    cout << "Error id " << exc.errorId() << endl; cout << "Exception id " << exc.exceptionId() << endl;
    cout << "Exception Class Name: " << exc.name() << endl;
    for (unsigned long i = 0; i< exc.textCount();i++) {
      cout << "Error text: " << exc.text(i) << endl;
      }
    for (unsigned long g=0; g< exc.locationCount();g++)  {
      const DKExceptionLocation* p = exc.locationAtIndex(g);
      cout << "Filename  : " << p->fileName() << endl;
      cout << "Function  : " << p->functionName() << endl;
      cout << "LineNumber: " << p->lineNumber() << endl;
      }

    if ((dsDL != NULL) && (dsDL->isConnected())) {
      dsDL->disconnect();
      cout << "datastore DL disconnected" << endl; 
      }
    if ((dsTS != NULL) && (dsTS->isConnected())) {
      dsTS->disconnect();
      cout << "datastore TS disconnected" << endl; 
      }
    if ((dsQBIC != NULL) && (dsQBIC->isConnected())) {
      dsQBIC->closeCatalog();
      dsQBIC->disconnect();
      cout << "datastore QBIC disconnected" << endl; 
      }
    }
  }            // while
cout << "done ..." << endl;
}








