//
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//

#include <iostream.h>
#include <stdio.h>
#include "DKException.hpp"
#include "DKDatastoreDES.hpp"
#include "DKAny.hpp"
#include "DKConstantDES.h"
#include "DKPid.hpp"
#include "dkXDO.hpp"
#include "DKOpCode.hpp"
#include "DKResults.hpp"
#include "DKDESQuery.hpp"
#include "DKPidXDODES.hpp"
#include "DKBlobDES.hpp"
#include "DKDate.hpp"

//*
//* Filename       : TCQExecuteDES.java
//* Description    : Connect to DES Datastore.
//*                  Create a DKCQExpr.
//*                  Specify to retrieve a max result of 2 items.
//*                  Get the result in a resultset cursor.
//*                  Loop thru results.
//*                  Display documents found and their parts and attributes,
//*                  Disconnect from DES Datastore.
//*

int main(int argc, char* argv[])
{
   cout << "begin..." << endl;
      //-------------------------------------------------------------- 
      // Checking for input parameters
      //--------------------------------------------------------------   
      if (argc < 5)
      {
       cout<<"Usage: "<<endl;
	     cout<< argv[0] << " <libsrv> <userid> <pw> <PORT=80;DESAPPID=appid;DESAPPPW=apppass[;DESCFGPATH=<des cfg file>;DESLOCALE=<locale>;]>" << endl;
       return 99;
      }
      // ### get input parameters
    DKString libsrv = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
    DKString str = argv[4];
    DKDatastoreDES dsDES;
    
    try 
	{
		cout << "connecting to datastore" << endl;
		dsDES.connect(libsrv,userid,pw,str);
		cout << "datastore connected libsrv: " << libsrv << " userid: " << userid << endl;

		if (dsDES.isConnected())
		{
			unsigned long ulCount = 0;
			cout << "connect to the DES datastore fine." << endl;
			dkCollection* pSeq = 0;
			dkIterator* pIter = 0;
			DKAny a;
			DKDDO *p = 0;
			dkDataObjectBase *pDOBase = 0;
			DKDDO* pDDO = 0;
			dkXDO *pXDO = 0;
			DKPidXDODES *pidXDO = 0;
			ushort j = 0;
			ushort k = 0;
			ushort val = 0;
			ushort cnt = 1;
			ushort numDataItems = 0;
			DKPid* pid;
			DKString strPid;
			long pidIdCnt = 0;
			long pidIndex = 0;
			DKString strDataName;
			DKString strData;
			dkCollection* pdCol = 0;
			dkIterator*  pdIter = 0;
			DKNVPair* parms = 0;

			DKNVPair* pAryOptions = new DKNVPair[1];
			DKNVPair* pNv = 0;
			DKCQExpr* pCqe = new DKCQExpr;
			DKQExpr* pQe = new DKQExpr;
			DKQTerm* pQterm = new DKQTerm("Subject", DK_DES_OPCODE_IN, "data");
			DKQSubExpr* pSqe = new DKQSubExpr;
			pCqe->setQLType(DK_CM_PARAMETRIC_QL_TYPE);
			pQe->setQLType(DK_CM_PARAMETRIC_QL_TYPE);
			pSqe->setTranslation(FALSE);
			pSqe->setEntityName("Notes 5 Help");
			pSqe->setQueryTerm(pQterm);
			DKString strTmp = "2";
			pNv = new DKNVPair("MAX_RESULTS", strTmp);
			pAryOptions[0] = *pNv;
			pSqe->setOptionList(pAryOptions, 1);
			pQe->addSubQuery(pSqe);
			pCqe->setQueryExpr(pQe);
			dkResultSetCursor* pCur = dsDES.execute(pCqe);

			while (pCur && pCur->isValid())
			{
				p = pCur->fetchNext();
				if (p)
				{
					cout << "==========> " << "Item " << cnt << " <=========" << endl;
					numDataItems = p->dataCount();
					pid = (DKPid*)p->getPidObject();
					strPid = pid->pidString();
					cout << "pid string " << strPid << endl;
					cout << "pid id string " << pid->getId() << endl;
					strPid = pid->getIdString();
					cout << "pid idString " << strPid << endl;
					pidIdCnt = pid->getIdStringCount();
					cout << "pid idString cnt " << pidIdCnt << endl;
					strPid = pid->getPrimaryId();
					cout << "pid primary id " << strPid << endl;
					pidIndex = 0;
					strPid = pid->getIdString(pidIndex);
					cout << "pid item id " << strPid << endl;
					k = p->propertyId(DK_PROPERTY_ITEM_TYPE);
					if (k > 0)
					{
						a = p->getProperty(k);
						val = a;
						cout << "******************************" << endl;
						switch (val)
						{
							case DK_DOCUMENT :
								cout << "Item is a document " << endl;
								break;
							default:
					             cout << " Item is not recognized " << endl;
								 break;
						}
						cout << "******************************" << endl;
					}
					cout << "Number of Data Items " << numDataItems << endl;
					for (j = 1; j <= numDataItems; j++)
					{
						a = p->getData(j);
						strDataName = p->getDataName(j);
						switch (a.typeCode())
						{
							case DKAny::tc_string :
								strData = a;
								cout << "attribute name : " << strDataName << " value : " << strData << endl;
							break;
							case DKAny::tc_long:
							{
								long l = a;
								cout << "attribute name : " << strDataName << " value : " << l << endl;
							}
							break;
							case DKAny::tc_double:
							{
								double db = a;
								cout << "attribute name : " << strDataName << " value : " << db << endl;
							}
							break;
							case DKAny::tc_timestamp :
							{
								DKTimestamp tt = a;
								cout << "attribute name : " << strDataName << " value : " 
									<< tt.getMonth() << "/" << tt.getDay() << "/" << tt.getYear() << " " 
									<< tt.getHours() << ":" << tt.getMinutes() << ":" << tt.getSeconds() << endl;
							}
							break;
							case DKAny::tc_dobase:
							{
								pDOBase = a;
								pXDO = (dkXDO*)pDOBase;
								cout << "attribute name : " << strDataName << " value : " << endl;
								pidXDO = (DKPidXDODES*)pXDO->getPidObject();
								cout << "XDO pid database name " << pidXDO->getDatabaseName() << endl;
								cout << "XDO pid docId " << pidXDO->getDocId() << endl;
								cout << "XDO mimetype " << pXDO->getMimeType() << endl;
								((DKBlobDES*)pXDO)->getContentToClientFile("c:\\temp\\temp.html", 1);
							}
							break;
							case DKAny::tc_collection :
							{
								pdCol = a;
								cout << strDataName << " collection name : " << strDataName << endl;
								cout << "--------------------------------------" << endl;
								pdIter = pdCol->createIterator();
								ushort b = 0;
								while (pdIter->more())
								{
									b++;
									cout << "  -------------------------------------------------" << endl;
									a = *(pdIter->next());
									switch (a.typeCode())
									{
									case DKAny::tc_string :
										strData = a;
										cout << "attribute name : " << strDataName << " value : " << strData << endl;
									break;
									case DKAny::tc_long :
									{
										long l = a;
										cout << "attribute name : " << strDataName << " value : " << l << endl;
									}
									break;
									case DKAny::tc_double :
									{
										double db = a;
										cout << "attribute name : " << strDataName << " value : " << db << endl;
									}
									break;
									case DKAny::tc_timestamp :
									{
										DKTimestamp tt = a;
										cout << "attribute name : " << strDataName << " value : " 
											<< tt.getMonth() << "/" << tt.getDay() << "/" << tt.getYear() << " " 
											<< tt.getHours() << ":" << tt.getMinutes() << ":" << tt.getSeconds() << endl;
									}
									break;
									case DKAny::tc_dobase :
									{
										pDOBase = a;
										pXDO = (dkXDO*)pDOBase;
										cout << "attribute name : " << strDataName << " value : " << endl;
										pidXDO = (DKPidXDODES*)pXDO->getPidObject();
										cout << "XDO pid database name " << pidXDO->getDatabaseName() << endl;
										cout << "XDO pid docId " << pidXDO->getDocId() << endl;
										cout << "XDO mimetype " << pXDO->getMimeType() << endl;
										DKString str = "c:\\temp\\temp";
										DKString strT = b;
										str = str + strT + ".html";
										((DKBlobDES*)pXDO)->getContentToClientFile(str, 1);
									}
									break;
									}
									ushort usCount = p->dataPropertyCount(j);
									for (ushort k = 1; k <= usCount; k++)
									{
										a = p->getDataProperty(j, k);
										cout << " property " << k << " " << a << endl;
									}	
									if (!b)
										cout << strDataName << " collection has no elements " << endl;
									cout << "  -------------------------------------------------" << endl;
								}
                                delete pdIter;
								break;
							}
						}
						ushort usCount = p->dataPropertyCount(j);
						for (ushort k = 1; k <= usCount; k++)
						{
							a = p->getDataProperty(j, k);
							cout << " property " << k << " " << a << endl;
						}	
					}
					cnt++;
					delete p;		// don't delete it if it's a DKResults*
				}	

			}	// while
				cout << "Total Item count is " << cnt-1 << endl;
			if (pIter)				// delete it if it's a DKResults*
				delete pIter;		// "

			if (pCur)
				delete pCur;

			delete pCqe;		// will delete qe, sqe, qterm accordinly
			delete pNv;
			delete []pAryOptions;

		}

		dsDES.disconnect();
		cout << "disconnect from the DES datastore fine." << endl;
		return 0;
	}
	catch (DKException& exc)
	{
		cout << "Failed to connect to the DES datastore." << endl;
		cout << "Error id " << exc.errorId() << endl;
		cout << "Exception id " << exc.exceptionId() << endl;
		for(unsigned long i = 0; i< exc.textCount();i++)
		{
			cout << "Error text: " << exc.text(i) << endl;
		}
		for (unsigned long g=0; g< exc.locationCount();g++)
		{
			const DKExceptionLocation* p = exc.locationAtIndex(g);
			cout << "Filename: " << p->fileName() << endl;
			cout << "Function: " << p->functionName() << endl;
			cout << "LineNumber: " << p->lineNumber() << endl;
		}
		cout << "Exception Class Name: " << exc.name() << endl;

		return -99;
	}
}
