#########################################################################################
# @copyright(disclaimer)                                                                #
# Licensed Materials - Property of IBM                                                  #
# IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43) #
# (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                            #
#                                                                                       #
# US Government Users Restricted Rights                                                 #
# Use, duplication or disclosure restricted by GSA ADP Schedule                         #
# Contract with IBM Corp.                                                               #
#                                                                                       #
# DISCLAIMER OF WARRANTIES :                                                            #
#                                                                                       #
# Permission is granted to copy and modify this Sample code, and to                     #
# distribute modified versions provided that both the copyright                         #
# notice,- and this permission notice and warranty disclaimer appear                    #
# in all copies and modified versions.                                                  #
#                                                                                       #
# THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                            #
# IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR        #
# IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE      #
# IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO      #
# EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF #
# THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR   #
# COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS      #
# LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR  #
# DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER      #
# CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR   #
# SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                       #
#                                                                                       #
# @endCopyright                                                                         #
#########################################################################################
#* ----------------------------------------------------------- *#
#* Name           : TAddAnnotationOD                           *#
#* Description    : make file                                  *#
#* ----------------------------------------------------------- *#

!IF "$(DEBUG)" == ""
DEBUG=0
!ENDIF

# EIP root directory
!IF "$(CMBROOT)" == ""
CMBROOT=C:\CMBROOT
!ENDIF

# Microsoft VC++ root directory MSVCDir
!IF "$(MSVCDIR)" == ""
MSVCDIR=C:\PROGRA~1\MICROS~1\VC98
!ENDIF

!IF "$(DKCMBPATH)" == ""
DKCMBPATH=$(CMBROOT)
!ENDIF

!IF "$(DKCMBLIBPATH)" == ""
DKCMBLIBPATH=$(DKCMBPATH)\lib
!ENDIF

!IF "$(DKCMBINCLUDEPATH)" == ""
DKCMBINCLUDEPATH=$(DKCMBPATH)\include
!ENDIF

!IF "$(MSDEV)" == ""
MSDEV=$(MSVCDIR)
!ENDIF

!IF "$(MSDEVLIBPATH)" == ""
MSDEVLIBPATH=$(MSDEV)\lib
!ENDIF

# determine location of MFC (based on version of VC++)
# and set DLL name
!MESSAGE -----------------------------------------------------------------------------
!IF "$(DKCPPVER)" == "6"
!MESSAGE *** Makefile set up to be compiled with Visual C++ 6 ***
DKMFCDIR=MFC
DKDLLVER=816
!ELSEIF "$(DKCPPVER)" == "7"
!MESSAGE *** Makefile set up to be compiled with Visual C++ 7 ***
DKMFCDIR=ATLMFC
DKDLLVER=817
!ELSE
!MESSAGE You must set environment variable DKCPPVER to 6 (for VC++6) or 7 (for VC++ 7)
!MESSAGE -----------------------------------------------------------------------------
!ERROR
!ENDIF
!MESSAGE -----------------------------------------------------------------------------
!MESSAGE #print blank line

!IF "$(MSDEVMFCLIBPATH)" == ""
MSDEVMFCLIBPATH=$(MSDEV)\$(DKMFCDIR)\lib
!ENDIF

DKINCLUDE=/I$(DKCMBINCLUDEPATH) /I$(MSDEV)\include /I$(MSDEV)\$(DKMFCDIR)\include
DKDEFINES=/D "WIN32" /D "_AFXDLL" /D "_MBCS" /D "_CONSOLE"

!IF  "$(DEBUG)" == "0"
OUTDIR=.\bin
INTDIR=.\obj

DKODLIB= $(DKCMBLIBPATH)\cmbcm$(DKDLLVER).lib $(DKCMBLIBPATH)\cmbod$(DKDLLVER).lib

DKRFLAGS = /d "NDEBUG"
DKCFLAGS =  /c /nologo /MD /W3 /O2 /GR /GX /D "NDEBUG" $(DKDEFINES) \
            /Fo"$(INTDIR)\\" /Fp"$(INTDIR)\TAddAnnotationOD.pch" /YX /Fd"$(INTDIR)\\" /FD

DKMPORTAL_CC = $(DKCFLAGS) $(DKINCLUDE) $(DKODINC)
DKMPORTAL_C = $(DKCFLAGS) $(DKINCLUDE) $(DKODINC)
DKLINKFLGS =/nologo /subsystem:console  /incremental:no \
 /pdb:"$(OUTDIR)\TAddAnnotationOD.pdb" /machine:I386 \
 /out:"$(OUTDIR)\TAddAnnotationOD.exe"

!ELSE
OUTDIR=.\db_bin
INTDIR=.\db_obj

DKODLIB= $(DKCMBLIBPATH)\cmbcm$(DKDLLVER)d.lib $(DKCMBLIBPATH)\cmbod$(DKDLLVER)d.lib

DKRFLAGS = /d "_DEBUG"
DKCFLAGS = /c /nologo /MDd /W3 /Od /GR /GM /Zi /GX /D "_DEBUG" $(DKDEFINES) \
           /Fd"$(INTDIR)\\" /Fo"$(INTDIR)\\" /Fp"$(INTDIR)\TAddAnnotationOD.pch" /YX /FR"$(INTDIR)\\"

DKMPORTAL_CC = $(DKCFLAGS) $(DKINCLUDE) $(DKODINC)
DKMPORTAL_C =  $(DKCFLAGS) $(DKINCLUDE) $(DKODINC)
DKLINKFLGS =/nologo /subsystem:console  /incremental:yes \
 /pdb:"$(OUTDIR)\TAddAnnotationOD.pdb" /DEBUG /machine:I386 \
 /out:"$(OUTDIR)\TAddAnnotationOD.exe"

!ENDIF

.cpp{$(INTDIR)}.obj:
   cl $(DKMPORTAL_CC) $<

DKEXE = "$(OUTDIR)\TAddAnnotationOD.exe"
DKOBJS = "$(INTDIR)\TAddAnnotationOD.obj"

all: "$(OUTDIR)" "$(INTDIR)" $(DKOBJS) $(DKEXE)

"$(OUTDIR)" :
    if not exist "$(OUTDIR)" mkdir "$(OUTDIR)"

"$(INTDIR)" :
    if not exist "$(INTDIR)" mkdir "$(INTDIR)"

"$(INTDIR)\TAddAnnotationOD.obj": .\TAddAnnotationOD.cpp

"$(OUTDIR)\TAddAnnotationOD.exe": $(DKOBJS)
        link $(DKODLIB) $(DKLINKFLGS) /LIBPATH:$(DKCMBLIBPATH) /LIBPATH:$(MSDEVLIBPATH) /LIBPATH:$(MSDEVMFCLIBPATH) $(DKOBJS)


