/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

import com.ibm.mm.beans.*;
import com.ibm.mm.beans.util.*;

import java.beans.*;

/**
 * This samples demonstrates using the CMBConnection bean to connect
 * to EIP's federated server.  This sample uses request and reply events.
 */
public class DemoConnectUsingEvent {
    SampleGuiLogon connGui = null;
    UtilSimpleUI ui = new UtilSimpleUI();

    CMBConnection connBean = null;
    CMBTraceLog traceBean = null;

    DemoConnectUsingEvent() {
        try {
            System.out.println("Creating CMBConnection bean using " + "ser/class/jar specified in the classpath.");
            connBean = (com.ibm.mm.beans.CMBConnection) Beans.instantiate(null, "com.ibm.mm.beans.CMBConnection");
            if (connBean.getServerName().length() == 0) {
                String srv = ui.getString("Server name is empty, " + "please enter the server name:");
                connBean.setServerName(srv);
            }

            System.out.println("Creating CMBTraceLog bean using " + "ser/class/jar specified in the classpath.");
            traceBean = (com.ibm.mm.beans.util.CMBTraceLog) Beans.instantiate(null, "com.ibm.mm.beans.util.CMBTraceLog");
            connBean.setTraceEnabled(true);
            connBean.addCMBTraceListener(traceBean);
            traceBean.setDisplayMode(CMBUtilConstant.DISPLAY_MESSAGE_IN_WINDOW);

            System.out.println("About bring up logon panel...");
            connGui = new SampleGuiLogon();
            connGui.addVetoableChangeListener(connBean);
            connGui.addCMBConnectionRequestListener(connBean);
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    public static void main(String argv[]) {
        String demoName = "IBM CMB Demonstration program: DemoConnectUsingEvent";
        String copyright = "C) Copyright IBM Corp. 1994,1999. All Rights Reserved.";

        System.out.println("");
        System.out.println(demoName);
        System.out.println(copyright);
        System.out.println("");
        System.out.println("");

        DemoConnectUsingEvent demo = new DemoConnectUsingEvent();
        boolean loopControl = true;

        while (loopControl) {
            if (!demo.connGui.isVisible())
                loopControl = false;
        }

        try {
            demo.connBean.disconnect();
        } catch (Exception e) {
        }
        demo.connGui.finalize();
        System.out.println("Bye.");
        System.exit(0);
    }
}