/*
 * @copyright(disclaimer) 
 * Licensed Materials - Property of IBM
 * IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
 * 
 * US Government Users Restricted Rights                                  
 *  Use, duplication or disclosure restricted by GSA ADP Schedule          
 *  Contract with IBM Corp.     
 * 
 * DISCLAIMER OF WARRANTIES :                                             
 *                                                                        
 * Permission is granted to copy and modify this  Sample code, and to           
 * distribute modified versions provided that both the copyright        
 * notice,- and this permission notice and warranty disclaimer  appear in all copies and modified  
 * versions. 
 * 
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
 * IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM     
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN 
 * SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF 
 * NON-INFRINGEMENT AND THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
 * PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR
 * SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT 
 * OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, 
 * DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION 
 * OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO 
 * EVENT SHALL IBM OR ITS LICENSORS AND SUPPLIERS BE 
 * LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, 
 * OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,
 * INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED 
 * AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF 
 * IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGES.                                     
 *                                                                  
 * @endCopyright
 */

import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import java.lang.*;
import java.awt.*;
/**
 * Stand-alone application for IBM EIP client.
 * Note:  The applet is CMBClientApplet.
 *
 */
public class SampleClient extends JFrame implements ClientInterface {

   // Do not remove - needed for copyright protection
   private static String COPYRIGHT = ClientPane.IBM_LONG_COPYRIGHT;

   private SampleClient applicationFrame;
   private ClientPane mainPane;

 
   public SampleClient() {
      super(ClientPane.PRODUCT_NAME);
      applicationFrame = this;   // save so inner class can access it
      SwingUtilities.invokeLater(new Runnable()  {
      public void run() {
       applicationFrame.setIconImage(mainPane.getImage("CC_SPLASH")); 
       applicationFrame.setBounds(100,100,700,500);
       mainPane = new ClientPane(applicationFrame.getContentPane(), applicationFrame);
       applicationFrame.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE );
       applicationFrame.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
            exitProgram();
         }
        });
       applicationFrame.setVisible(true);
            //applicationFrame.setBounds(100,100,501,300);//setBounds again so that the screen repaints...now
               // to do check if userIDText field has the focus on logon
               // panel
          }
      } );
   }
    
   
   public static void main (String[] args) {
   	  ClientPane.setLookAndFeel( null );
      SampleClient client = new SampleClient();
   }

   public void exitProgram() {
      if (mainPane != null) {
        try {
         mainPane.logoff();
        }catch (ShouldNotOccurException exc) {
            //EJMTrace.trace(EJMTrace.INFO,this,"Federation Manager logoff request has been rejected.");
            System.out.println("Federation Manager logoff request has been rejected.");
            this.dispose();
            System.exit(0);
        } catch (Exception e) {
            System.out.println("Federation Manager logoff request has been rejected: " + e.toString());
            this.dispose();
            System.exit(0);
        }
      }
      //EJMTrace.trace(EJMTrace.INFO,this,"Federation Manager logoff request accepted, window closing");
      this.dispose();
      System.exit(0);
   }

   public void displayHelp() {  

    // Create a Frame with editor pane
    JFrame frame = new JFrame();
    frame.setTitle("EIP Client Help");
    frame.setBounds(350, 150, 700, 600);
    frame.getContentPane().setLayout(new BorderLayout());
    JTextPane helpPane = new JTextPane();
    helpPane.setEditable(false);
    frame.getContentPane().add(new JScrollPane(helpPane));
    try {
        helpPane.setPage(new java.net.URL(mainPane.helpURLString));
        frame.setVisible(true);
    } catch (java.net.MalformedURLException ex) {
        MessageBox mb = new MessageBox(this, ResourceMgr.getString( "TITLEBAR_TITLE"), "Malformed Help URL given: " + mainPane.helpURLString,50,null);
    } catch (java.io.IOException ex) {
        MessageBox mb = new MessageBox(this, ResourceMgr.getString( "TITLEBAR_TITLE"), ex.getMessage(),50, null);
    }

   }

   public JFrame getMainFrame() {
      return this;
   }
}



