/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Information Integrator for Content V8.2  (program number 5724-B43)             *
 * (c ) Copyright IBM Corp. 1998, 2002, 2003. All Rights Reserved.                    *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************

Internal Class Used by the XML tools.  Used by TXMLAttrDefImportICM
and TXMLItemTypeDefImportICM

Not a sample program and not meant for reference material.
 
********************************************************************/

import org.apache.xerces.parsers.DOMParser;
import org.apache.xerces.*;
import org.w3c.dom.*;
import org.xml.sax.*;

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;

import java.util.Vector;
import java.sql.Date;
import java.io.IOException;
import java.lang.*;

/************************************************************************************************
 *          FILENAME: TXMLInternalValidatingParserICM.java
 *                    ---------------------------------------------------------------------------
 *       DESCRIPTION: Internal classes used by XML Tools.  Parses an XML file follwing the dtd.
 *                    ---------------------------------------------------------------------------
 *     DEMONSTRATION: Not a sample program.  This file is a tool provided as-is.
 *                    ---------------------------------------------------------------------------
 * COMMANDLINE USAGE: None.  Not a sample program.
 *                    ---------------------------------------------------------------------------
 *      PREREQUISITS: Classpath must contain file location of xerces.jar.
 *                    ---------------------------------------------------------------------------
 *    FILES REQUIRED: none
 ************************************************************************************************/
class TXMLInternalValidatingParserICM implements ErrorHandler{
   
    TXMLInternalValidatingParserICM() throws Exception{
    }

   /**
    * Open xml file with data.
    * Structure of the file has to match with the Itemsets in LS.
    * @param fileName xml file name
    **/
    Document open(String fileName) throws Exception{
	    DOMParser parser = new DOMParser();
	
	    //  Turn Validation on
        parser.setFeature("http://xml.org/sax/features/validation", true);
        //  Register Error Handler
        parser.setErrorHandler (this);

        parser.parse(fileName);
        return parser.getDocument();
    }

    //  Warning Event Handler
    public void warning (SAXParseException e)throws SAXException {
        System.err.println ("Warning:  "+e);
        throw e;
    }
    
    //  Error Event Handler
    public void error (SAXParseException e) throws SAXException {
        System.err.println ("Error:  "+e);
        throw e;
    }
                
    //  Fatal Error Event Handler
    public void fatalError (SAXParseException e)throws SAXException {
            System.err.println ("Fatal Error:  "+e);
            throw e;
    }
                
}//end TXMLInternalValidatingParserICM
